<template>
  <v-flex xs12 sm6>
    <v-card>
      <v-card-title primary-title>
        <div>
          <h3 class="headline mb-0">Network Prediction</h3>
        </div>
      </v-card-title>
      <v-responsive>
        <div ref="plot" ></div>
      </v-responsive>
      <!-- <v-card-actions>
        <v-btn flat color="orange">Share</v-btn>
        <v-btn flat color="orange">Explore</v-btn>
      </v-card-actions> -->
    </v-card>
  </v-flex>
</template>

<script>
const axios = require('axios')
import * as tf from '@tensorflow/tfjs'

import Plotly from 'plotly.js-dist'
import plotly_layout from '~/assets/plotly_layout.json'

export default {
  name: 'Countrate',
  data() {
    return {
      info: null,
      model: null,
      prediction: null
    }
  },
  methods: {
    load_spectrum() {
      function range(i) {
        return i ? range(i - 1).concat(i) : []
      }

      var config = {
        headers: {
          'Content-Type': 'application/json',
          'Cache-Control': 'no-cache'
        }
      }
      axios.get('/d/spec.json').then(response => (this.info = response), config)
    },
    async load_model() {
      this.model = await tf.loadModel('/m/m1.json')
      return this.model
    }
  },
  created() {},
  mounted() {
    this.$watch('prediction', function(newVal, oldVal) {
      console.log('Drawing Prediction')
      var data = [
        {
          x: this.prediction,
          y: [
            'isotope_1',
            'isotope_2',
            'isotope_3',
            'isotope_4',
            'isotope_5',
            'isotope_6',
            'isotope_7',
            'isotope_8',
            'isotope_9',
            'isotope_10',
            'isotope_11',
            'isotope_12',
            'isotope_13'
          ],
          type: 'bar',
          orientation: 'h'
        }
      ]

      let layout = {
        ...plotly_layout,
        ...{}
      }

      Plotly.newPlot(this.$refs.plot, data, layout)
    })
    this.$watch(
      function() {
        return [this.model, this.info]
      },
      function(newVal, oldVal) {
        if (!this.model) {
          return
        }
        if (!this.info) {
          return
        }
        this.prediction = this.model
          .predict(tf.tensor(this.info.data.spectrum_00))
          .dataSync()
      }
    )
    this.load_model()
    this.load_spectrum()
  }
}
</script>
